<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.coupon_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/mall/coupon";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          // index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "优惠券名称",
              labelWidth: 150,
              prop: "title",
              rules: [{
                required: true,
                message: "请输入优惠券名称",
                trigger: "blur"
              }]
            },
            {
              label: "优惠券类型",
              labelWidth: 150,
              prop: "preferentialType",
              type: "select",
              dicUrl: "/api/blade-system/dict-biz/getEnumDict?enumName=PreferentialTypeEnum",
              props: {
                label: "name",
                value: "value"
              },
              dataType: "number",
              rules: [{
                required: true,
                message: "请输入优惠券优惠的类型",
                trigger: "blur"
              }]
            },
            {
              label: "使用范围",
              labelWidth: 150,
              prop: "type",
              type: "select",
              dicUrl: "/api/blade-system/dict-biz/getEnumDict?enumName=CouponTypeEnum",
              props: {
                label: "name",
                value: "value"
              },
              dataType: "number",
              rules: [{
                required: true,
                message: "请输入优惠券类型",
                trigger: "blur"
              }]
            },
            {
              label: "业务场景",
              labelWidth: 150,
              prop: "businessScene",
              type: "select",
              dicUrl: "/api/blade-system/dict-biz/getEnumDict?enumName=BusinessSceneEnum",
              props: {
                label: "name",
                value: "value"
              },
              dataType: "number",
              rules: [{
                required: true,
                message: "请选择业务场景",
                trigger: "blur"
              }],
            },
            {
              label: "有效天数",
              labelWidth: 150,
              prop: "validDays",
              hide: true,
              rules: [{
                required: true,
                message: "请输入有效天数",
                trigger: "blur"
              }],
            },
            {
              label: "开始使用时间",
              labelWidth: 150,
              prop: "startTime",
              hide: true,
              rules: [{
                required: true,
                message: "请输入开始使用时间",
                trigger: "blur"
              }],
              type: "datetime",
              format: "yyyy-MM-dd",
              valueFormat: "yyyy-MM-dd 00:00:00",
            },
            {
              label: "结束使用时间",
              hide: true,
              labelWidth: 150,
              prop: "endTime",
              rules: [{
                required: true,
                message: "请输入结束使用时间",
                trigger: "blur"
              }],
              type: "datetime",
              format: "yyyy-MM-dd",
              valueFormat: "yyyy-MM-dd 23:59:59",
            },
            {
              label: "折扣比例",
              labelWidth: 150,
              prop: "discountRatio",
              rules: [{
                required: true,
                message: "请输入折扣比例",
                trigger: "blur"
              }]
            },
            {
              label: "满减金额",
              labelWidth: 150,
              prop: "fullReduction",
              rules: [{
                required: true,
                message: "请输入满减金额",
                trigger: "blur"
              }]
            },
            {
              label: "优惠金额",
              labelWidth: 150,
              prop: "discountAmount",
              rules: [{
                required: true,
                message: "请输入优惠金额",
                trigger: "blur"
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.coupon_add, false),
          viewBtn: this.vaildData(this.permission.coupon_view, false),
          delBtn: this.vaildData(this.permission.coupon_delete, false),
          editBtn: this.vaildData(this.permission.coupon_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    created() {
      this.option.column[3].change = function (column) {
        if (column.value == 1) {
          this.showUserTime(false, "add");
        } else {
          this.showUserTime(true, "add")
        }
      }.bind(this);
    },
    methods: {
      showUserTime(value, type) {
        const startTime = this.findObject(this.option.column, "startTime");
        this.$set(startTime, type + 'Display', value)
        const endTime = this.findObject(this.option.column, "endTime");
        this.$set(endTime, type + 'Display', value)
        const validDays = this.findObject(this.option.column, "validDays");
        this.$set(validDays, type + 'Display', !value)
      },
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
            if (this.form.businessScene == 1) {
              this.showUserTime(false, type);
            } else {
              this.showUserTime(true, type)
            }
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
